package org.stonybrookschool.dailyBulletin;

import java.io.*;
import java.sql.*;
import java.util.*;
import java.text.*;

import javax.servlet.*;
import javax.servlet.http.*;

import org.stonybrookschool.dailyBulletin.*;
import org.stonybrookschool.dailyBulletin.data.*;
import org.stonybrookschool.dailyBulletin.objects.*;

public class viewer extends HttpServlet
{

    String templateBase = "/dailyBulletin/templates/";
    String template = "";

    public void doGet (HttpServletRequest req, HttpServletResponse res)
        throws ServletException, IOException
    {
        handle(req, res);
    }

    public void doPost (HttpServletRequest req, HttpServletResponse res)
        throws ServletException, IOException
    {
        handle(req, res);
    }

    public void handle (HttpServletRequest req, HttpServletResponse res)
        throws ServletException, IOException
    {
	res.setContentType( "text/html" );

	String page = req.getParameter( "page" );

	if ( ( page != null ) && ( ! "".equals( page ) ) ) {
	    if ( page.equals( "frontPage" ) )
		template = doFrontPage( req, res );
	    if ( page.equals( "login" ) )
		template = doProcessLogin( req, res );
	    if ( page.equals( "logout" ) )
		template = doProcessLogout( req, res );
	    if ( page.equals( "story" ) )
                template = doStory( req, res );
            if ( page.equals( "edit" ) )
                template = doEditList( req, res );
 	    if ( page.equals( "editStory" ) )
		template = doEditStory( req, res );
	    if ( page.equals( "postEdit" ) )
		template = doPostEdit( req, res );
            if ( page.equals( "admin" ) )
                template = doAdminEditList( req, res );
 	    if ( page.equals( "adminEditStory" ) )
		template = doAdminEditStory( req, res );
	    if ( page.equals( "adminPostEdit" ) )
		template = doAdminPostEdit( req, res );

	}
	else
	    template = doFrontPage( req, res );

	if ( req.getParameter( "template" ) != null )
	    template = templateBase + req.getParameter( "template" );

	// execute the jsp page
	RequestDispatcher rd = req.getRequestDispatcher( template );
	rd.include( req, res );

    }

    public String doFrontPage( HttpServletRequest req, HttpServletResponse res )
	throws ServletException, IOException
    {
	Vector sv = new Vector( );
	String edition;
	String dateString = "";

	if ( req.getSession( ).getAttribute( "org.stonybrookschool.dailyBulletin.objects.user" ) != null ) {
	    User u = (User) req.getSession( ).getAttribute( "org.stonybrookschool.dailyBulletin.objects.user" );
	    if ( "t".equals( u.getStaff( ) ) ) {
		if ( req.getParameter( "edition" ) != null ) {
		    if ( "student".equals( req.getParameter( "edition" ) ) )
			edition = "student";
		    else 
			if ( "parent".equals( req.getParameter( "edition" ) ) )
			    edition = "parent";
			else
			    edition = "staff";
		    req.getSession( ).setAttribute( "edition", edition );
		}
	    }
	}
	else { // not logged in
	    req.getSession( ).setAttribute( "edition", CommonRoutines.getEdition( req.getRemoteAddr( ) ) );
	}

	if ( req.getParameter( "date" ) != null ) {
	    dateString = (String) req.getParameter( "date" );
	}
	else {
	    SimpleDateFormat sdf = new SimpleDateFormat( "yyyy-MM-dd hh:mm:ss" );
	    dateString = sdf.format( new java.util.Date( ) );
	}

	sv = DBRoutines.getStories( (String) req.getSession( ).getAttribute( "edition" ), dateString );

	req.setAttribute( "date", dateString );
	req.setAttribute( "storyVector", sv );

	return( templateBase + "frontPage.jsp" );
    }

    public String doProcessLogin( HttpServletRequest req, HttpServletResponse res )
	throws ServletException, IOException
    {
	String username = req.getParameter( "username" );
	String password = req.getParameter( "password" );
	if ( username != null ) {
	    if ( password != null ) {
		if ( DBRoutines.checkPassword( username, password ) ) {
		    User u = DBRoutines.getUser( username );
		    req.getSession( ).setAttribute( "org.stonybrookschool.dailyBulletin.objects.user", u );
		    if ( "t".equals( u.getStaff( ) ) )
			req.getSession( ).setAttribute( "edition", "staff" );
		    else
			req.getSession( ).setAttribute( "edition", "student" );
		}
	    }
	}
	return( doFrontPage( req, res ) );
    }

    public String doProcessLogout( HttpServletRequest req, HttpServletResponse res )
	throws ServletException, IOException
    {
	req.getSession( ).setAttribute( "org.stonybrookschool.dailyBulletin.objects.user", null );
	req.getSession( ).setAttribute( "edition", null );

	return( doFrontPage( req, res ) );
    }

    public String doEditList( HttpServletRequest req, HttpServletResponse res )
        throws ServletException, IOException
    {
	User u = (User) req.getSession( ).getAttribute( "org.stonybrookschool.dailyBulletin.objects.user" );
	Vector sv = DBRoutines.getUserOndeckStories( u.getId( ) );
	req.setAttribute( "storyVector", sv );

        return( templateBase + "editList.jsp" );
    }

    public String doAdminEditList( HttpServletRequest req, HttpServletResponse res )
        throws ServletException, IOException
    {
	User u = (User) req.getSession( ).getAttribute( "org.stonybrookschool.dailyBulletin.objects.user" );
	if ( "t".equals( u.getPublisher( ) ) ) {
	    Vector sv = DBRoutines.getOndeckStories( );
	    req.setAttribute( "storyVector", sv );

	    return( templateBase + "adminEditList.jsp" );
	}
	else {
	    return( templateBase + "frontPage.jsp" );
	}
    }

    public String doEditStory( HttpServletRequest req, HttpServletResponse res )
        throws ServletException, IOException
    {
	int storyId;
	Story s;
	User u = (User) req.getSession( ).getAttribute( "org.stonybrookschool.dailyBulletin.objects.user" );

	storyId = Integer.parseInt( req.getParameter( "storyId" ) );

	if ( storyId > 0 )
	    s = DBRoutines.getStory( storyId );
	else {
	    s = new Story( );
	    s.setUserId( u.getId( ) );
	}

	req.setAttribute( "story", s );

        return( templateBase + "edit.jsp" );
    }

    public String doAdminEditStory( HttpServletRequest req, HttpServletResponse res )
        throws ServletException, IOException
    {
	int storyId;
	Story s;
	User u = (User) req.getSession( ).getAttribute( "org.stonybrookschool.dailyBulletin.objects.user" );

	storyId = Integer.parseInt( req.getParameter( "storyId" ) );

	if ( storyId > 0 )
	    s = DBRoutines.getStory( storyId );
	else {
	    s = new Story( );
	    s.setUserId( u.getId( ) );
	}

	req.setAttribute( "story", s );

        return( templateBase + "adminEdit.jsp" );
    }

    public String doPostEdit( HttpServletRequest req, HttpServletResponse res )
        throws ServletException, IOException
    {
	boolean publisher = false;
	Story s = new Story( );
	Story p = new Story( );
	User u = (User) req.getSession( ).getAttribute( "org.stonybrookschool.dailyBulletin.objects.user" );
	int storyId = Integer.parseInt( req.getParameter ( "storyId" ) );

	if ( "t".equals( u.getPublisher( ) ) )
	    publisher = true;

	if ( ! "".equals( req.getParameter( "head" ) ) ) {
	    if ( storyId > 0 )
		p = DBRoutines.getStory( storyId );
	    s.setId( storyId );
	    s.setPublishDate( req.getParameter( "publishYear" ) + "-" +
			      req.getParameter( "publishMonth" ) + "-" +
			      req.getParameter( "publishDay" ) + " 00:00:00" );
	    s.setUnpublishDate( req.getParameter( "unpublishYear" ) + "-" +
				req.getParameter( "unpublishMonth" ) + "-" +
				req.getParameter( "unpublishDay" ) + " 00:00:00" );
	    if ( "on".equals( req.getParameter( "student" ) ) )
		s.setStudent( "t" );
	    else
		s.setStudent( "f" );
	    if ( "on".equals( req.getParameter( "staff" ) ) )
		s.setStaff( "t" );
	    else
		s.setStaff( "f" );
	    if ( "on".equals( req.getParameter( "parent" ) ) )
		s.setParent( "t" );
	    else
		s.setParent( "f" );
	    if ( publisher )
		s.setPriority( Integer.parseInt( req.getParameter( "priority" ) ) );
	    else
		if ( storyId > 0 )
		    s.setPriority( p.getPriority( ) );
		else 
		    s.setPriority( 10 );
	    s.setHead( CommonRoutines.escapeHTML( req.getParameter( "head" ) ) );
	    s.setText( CommonRoutines.escapeHTML( req.getParameter( "text" ) ) );
	    if ( storyId > 0 )
		s.setUserId( p.getUserId( ) );
	    else
		s.setUserId( u.getId( ) );
	    if ( publisher )
		s.setState( req.getParameter( "state" ) );
	    else
		s.setState( "pending" );
	    
	    if ( storyId == 0 )
		DBRoutines.insertStory( s );
	    else
		DBRoutines.updateStory( s );
	}
	else { // no headline
	    // need to deal with this error
	}

        return( doEditList( req, res ) ); 
    }

    public String doAdminPostEdit( HttpServletRequest req, HttpServletResponse res )
        throws ServletException, IOException
    {
	boolean publisher = false;
	Story s = new Story( );
	Story p = new Story( );
	User u = (User) req.getSession( ).getAttribute( "org.stonybrookschool.dailyBulletin.objects.user" );
	int storyId = Integer.parseInt( req.getParameter ( "storyId" ) );

	if ( "t".equals( u.getPublisher( ) ) )
	    publisher = true;

	if ( ! "".equals( req.getParameter( "head" ) ) ) {
	    if ( storyId > 0 )
		p = DBRoutines.getStory( storyId );
	    s.setId( storyId );
	    s.setPublishDate( req.getParameter( "publishYear" ) + "-" +
			      req.getParameter( "publishMonth" ) + "-" +
			      req.getParameter( "publishDay" ) + " 00:00:00" );
	    s.setUnpublishDate( req.getParameter( "unpublishYear" ) + "-" +
				req.getParameter( "unpublishMonth" ) + "-" +
				req.getParameter( "unpublishDay" ) + " 00:00:00" );
	    if ( "on".equals( req.getParameter( "student" ) ) )
		s.setStudent( "t" );
	    else
		s.setStudent( "f" );
	    if ( "on".equals( req.getParameter( "staff" ) ) )
		s.setStaff( "t" );
	    else
		s.setStaff( "f" );
	    if ( "on".equals( req.getParameter( "parent" ) ) )
		s.setParent( "t" );
	    else
		s.setParent( "f" );
	    if ( publisher )
		s.setPriority( Integer.parseInt( req.getParameter( "priority" ) ) );
	    else
		if ( storyId > 0 )
		    s.setPriority( p.getPriority( ) );
		else 
		    s.setPriority( 10 );
	    s.setHead( CommonRoutines.escapeHTML( req.getParameter( "head" ) ) );
	    s.setText( CommonRoutines.escapeHTML( req.getParameter( "text" ) ) );
	    if ( storyId > 0 )
		s.setUserId( p.getUserId( ) );
	    else
		s.setUserId( u.getId( ) );
	    if ( publisher )
		s.setState( req.getParameter( "state" ) );
	    else
		s.setState( "pending" );
	    
	    if ( storyId == 0 )
		DBRoutines.insertStory( s );
	    else
		DBRoutines.updateStory( s );
	}
	else { // no headline
	    // need to deal with this error
	}

        return( doAdminEditList( req, res ) ); 
    }

    public String doStory( HttpServletRequest req, HttpServletResponse res )
        throws ServletException, IOException
    {
	String template = "";

	if ( req.getParameter( "storyId" ) != null ) {
	    if ( ! "".equals( req.getParameter( "storyId" ) ) ) { 
		int storyId = Integer.parseInt( req.getParameter( "storyId" ) );
		Story s = DBRoutines.getStory( storyId );
		req.setAttribute( "story", s );
		template = "story.jsp";
	    }
	    else {
		req.setAttribute( "message", "empty story id" );
		template = "error.jsp";
	    }
	}
	else {
	    req.setAttribute( "message", "null story id" );
	    template = "error.jsp";
	}

	return ( templateBase + template );

    }

}







